﻿using System.Windows;

namespace TreeViewAutoExpand
{
  using System;
  using System.Windows.Controls;
  using System.Windows.Media.Animation;

  public partial class MainWindow : Window
  {
    public MainWindow()
    {
      InitializeComponent();
    }

    private void MyTreeView_Loaded(object sender, RoutedEventArgs e)
    {
      BooleanAnimationUsingKeyFrames bukf = new BooleanAnimationUsingKeyFrames();
      Storyboard.SetTargetProperty(bukf, new PropertyPath(TreeViewItem.IsExpandedProperty));

      Storyboard.SetTarget(bukf, MyTreeView);

      foreach (object item in MyTreeView.Items)
      {
        TreeViewItem currentContainer = (TreeViewItem)MyTreeView.ItemContainerGenerator.ContainerFromItem(item);
        if (currentContainer != null)
        {
          Storyboard.SetTarget(bukf, currentContainer);
        }
      }

      bukf.KeyFrames.Add(new DiscreteBooleanKeyFrame(false, KeyTime.FromTimeSpan(TimeSpan.FromSeconds(0.0))));
      bukf.KeyFrames.Add(new DiscreteBooleanKeyFrame(true, KeyTime.FromTimeSpan(TimeSpan.FromSeconds(2.0))));

      Storyboard myStoryboard = new Storyboard();
      myStoryboard.Children.Add(bukf);
      myStoryboard.Begin();

    }
  }
}